﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using Infragistics.Windows;
using Infragistics.Windows.DataPresenter;
using Infragistics.Windows.Editors;
using System.Data;

namespace XamComboBinding
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        DataTable data = new DataTable();
        public MainWindow()
        {
            try
            {
                InitializeComponent();

                data.Columns.Add("Country", typeof(System.String));
                data.Columns.Add("Cities", typeof(System.String));

                data.Rows.Add(AddRow("USA", "NY"));
                data.Rows.Add(AddRow("Bulgaria", "Varna"));
                data.Rows.Add(AddRow("England", "London"));
                data.Rows.Add(AddRow("Bulgaria", "Sofia"));
                
                xamDataGrid1.DataSource = data.DefaultView;

                if (xamDataGrid1.Records.FieldLayout != null)
                {
                    Style editAttributeStyle = new System.Windows.Style();
                    editAttributeStyle = (Style)this.TryFindResource("EditButtonStyle");

                    UnboundField fieldIsEditable = new UnboundField();
                    fieldIsEditable.Name = "IsAttributeEditable";
                    fieldIsEditable.Label = "";
                    fieldIsEditable.Settings.CellValuePresenterStyle = editAttributeStyle;
                    fieldIsEditable.Settings.AllowCellVirtualization = false;

                    xamDataGrid1.Records.FieldLayout.Fields.Add(fieldIsEditable);
                    fieldIsEditable.Visibility = System.Windows.Visibility.Visible;

                    xamDataGrid1.UpdateLayout();
                    System.Windows.Forms.Application.DoEvents();

                    //foreach (DataRecord drEditAttrRec in xamDataGrid1.Records)
                    //{
                    //    //xamDataGrid1.BringCellIntoView(drEditAttrRec.Cells["IsAttributeEditable"]);
                    //    if (Convert.ToString(drEditAttrRec.Cells["Country"].Value) == "Bulgaria")
                    //    {
                    //        ((Image)Utilities.GetDescendantFromName(CellValuePresenter.FromCell(drEditAttrRec.Cells["IsAttributeEditable"]), "imgEdit")).Visibility = System.Windows.Visibility.Visible;
                    //    }
                    //    else
                    //    {
                    //        ((Image)Utilities.GetDescendantFromName(CellValuePresenter.FromCell(drEditAttrRec.Cells["IsAttributeEditable"]), "imgEdit")).Visibility = System.Windows.Visibility.Hidden;
                    //    }
                    //}
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Error", MessageBoxButton.OK, MessageBoxImage.Error);
            }
        }


        private DataRow AddRow(String pCountry, string pCity)
        {
            DataRow dr = data.NewRow();

            dr["Country"] = pCountry;
            dr["Cities"] = pCity;

            return dr;
        }

    }

    public class Data
    {
        public string Country { get; set; }

        public static List<string> GetAreas(String Country)
        {
            switch (Country)
            {
                case ("USA"):
                    return new List<string>() { "NY", "LA" };
                case ("England"):
                    return new List<string>() { "London", "Liverpool" };
                case ("Bulgaria"):
                    return new List<string>() { "Sofia", "Varna" };
                default:
                    return new List<string>() { "No Area" };
            }
        }
    }

    public class VisibilityConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if ( value != null && value.ToString() == "Bulgaria")
            {
                return System.Windows.Visibility.Visible;
            }
            else
            {
                return System.Windows.Visibility.Hidden;
            }
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }

}
